; File:     Edit7.asm
; Rui Loureiro
;------------------------------------------------------------------------------------------------------------------*****
   .586
    .model  flat, stdcall
    option  casemap :none
; 
    include \masm32\include\windows.inc
    include \masm32\macros\macros.asm

    include \masm32\include\kernel32.inc
    include \masm32\include\user32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\comdlg32.inc            ; printer
    include \masm32\include\Comctl32.inc
;----------------------------------------------
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\comdlg32.lib             ; printer
    includelib \masm32\lib\Comctl32.lib


EditaLin        proto   :DWORD,:DWORD

WinMain         proto   :DWORD,:DWORD,:DWORD,:DWORD
WndProcA        proto   :DWORD,:DWORD,:DWORD,:DWORD
WndEdit1        proto   :DWORD,:DWORD,:DWORD,:DWORD
WndEdit2        proto   :DWORD,:DWORD,:DWORD,:DWORD
WndEdit3        proto   :DWORD,:DWORD,:DWORD,:DWORD


PrintText       proto   :DWORD,:DWORD,:DWORD
CriaEditBox     proto   :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

CREATEEDIT macro X, Y, W, H, ID, Style
invoke   CreateWindowEx,  0, offset _EDITClass, 0,
                          Style,
                          X, Y, W, H,
                          hWnd,
                          ID,
                          _hInstance,
                          0
ENDM 
; 
EDITSTYLE1      equ WS_CHILD or WS_TABSTOP or WS_VISIBLE or ES_LEFT or ES_AUTOHSCROLL
EDITSTYLE2      equ EDITSTYLE1 or WS_BORDER
; 
.const
MAIN_STYLE       equ WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN     
MAIN_EXTSTYLE    equ 300h
$ECRAWIDTH$      equ 600  ;1280    ;800                     ; largura do ecr
$ECRAHEIGHT$     equ 300  ;800     ;570                     ; altura do ecr
;
IDM_Menu1       equ 1010
IDM_Menu2       equ 1020
IDM_Menu3       equ 1030
IDM_Menu4       equ 1040
IDM_Menu5       equ 1050

;  Data Section 
.data
; ----------------------------------------------------------------------------------------------
_BUTTONClass    db "BUTTON",0           ;name of window class
_STATICClass    db "STATIC",0           ;name of window class
_EDITClass      db "EDIT",0             ;name of window class

_hEDIT1         dd 0
_hEDIT2         dd 0
_hEDIT3         dd 0
                ;
_LinCor         dd 4
_FlgEdita       dd 0

                dd 22
_TxtEDIT0       db 'Use RETURN, ESC or END'

                dd 20
                dd 11
_TxtEDIT1       db 'Text edit 1'
                db 12 dup (0)
                ;
                dd 20
                dd 11
_TxtEDIT2       db 'Text edit 2'
                db 12 dup (0)

                dd 20
                dd 11
_TxtEDIT3       db 'Text edit 3'
                db 12 dup (0)

_FontMSSSerif   db "MS Sans Serif",0
_hFont0         dd 0
_hFont1         dd 0
;....................................................................................
_hWnd        dd 0
_ClassName   db 'WinClass',0
_MenuName    db 'Menu',0

_WindowName  db 'Edit Text',0

                dd 16
                dd 0
_RclBuffer      db 17 dup (0)
;  Data? Section 
.data?
;---------------------------------------
_BkColor     dd ?

_hInstance   dd ?
_hdc         dd ?
_ChrWidth    dd ?
_ChrHeight   dd ?
;---------------------------------------
_wcx         WNDCLASSEX <?>
_msg         MSG <?>

_tm          TEXTMETRIC  <?>
_rc          RECT <?>

_OldEdit1   dd ?
_OldEdit2   dd ?
_OldEdit3   dd ?
;  Code Section 
.code
;---------------------------------------
start:
    invoke  GetModuleHandle, NULL
    mov     _hInstance, eax

    invoke  WinMain, _hInstance, NULL, NULL, SW_SHOWDEFAULT
; ##############################################################################################
align 16
WinMain     proc    hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
            LOCAL   x,y:DWORD
            
            ; Window size and coordinates to center it on the screen
            ;-------------------------------------------------------
            invoke  GetSystemMetrics, SM_CXSCREEN
            shr     eax, 1
            sub     eax, $ECRAWIDTH$ / 2
            mov     x, eax
            invoke  GetSystemMetrics, SM_CXSCREEN
            shr     eax, 1
            sub     eax, $ECRAHEIGHT$ / 2
            sub     eax, 80
            mov     y, eax

            ;.................................................................
            ;
            ; Preencher a estrutura WNDCLASSEX para a janela 1
            ; ------------------------------------------------
	      mov   _wcx.cbSize,      SIZEOF WNDCLASSEX
            mov   _wcx.style,       3 or CS_BYTEALIGNCLIENT or CS_OWNDC         
    	      mov   _wcx.lpfnWndProc, OFFSET WndProcA
        	mov   _wcx.cbClsExtra,  NULL
	      mov   _wcx.cbWndExtra,  NULL
	      push  _hInstance
	      pop   _wcx.hInstance

            ;invoke  GetSysColor, COLOR_WINDOW
            invoke  GetSysColor, COLOR_BACKGROUND
            mov      _BkColor, eax

            ;invoke  GetSysColorBrush, COLOR_WINDOW
            invoke  GetSysColorBrush, COLOR_BACKGROUND            
        	mov   _wcx.hbrBackground, eax  ;COLOR_WINDOW+1   ;COLOR_BACKGROUND+1           
	      mov   _wcx.lpszMenuName, offset _MenuName            ; menu name in resource file
	      mov   _wcx.lpszClassName, offset _ClassName          ; name of windows class
            mov    _wcx.hIcon, NULL                         
            mov    _wcx.hIconSm, NULL
        	invoke LoadCursor, NULL, IDC_ARROW
        	mov   _wcx.hCursor, eax

            invoke RegisterClassEx, addr _wcx

            mov       _LinCor, 4
            ; 
            ; Get Display DC before WM_CREATE
            ; 
            ;call    GetDisplayDC
            
            ; 
            ;  Main Window
            ; 
	      invoke CreateWindowEx, MAIN_EXTSTYLE, addr _ClassName, addr _WindowName, MAIN_STYLE,
                                   x, y, $ECRAWIDTH$, $ECRAHEIGHT$, 
                                   NULL, NULL, hInst, NULL
            mov     _hWnd, eax                                     

            ; 
            ; Get Display DC after WM_CREATE
            ; 
            call    GetDisplayDC


            invoke    EditaLin, _hWnd, _LinCor
            invoke    SetFocus, _hEDIT1

              
            invoke  ShowWindow, _hWnd, SW_SHOWNORMAL
            invoke  UpdateWindow, _hWnd           
;#############################################################################
            ;
            ; Loop de espera de mensagens
            ;
@@:         invoke  GetMessage, ADDR _msg, NULL, 0, 0                       
            cmp     eax,0h                              ;check if return value=0 => exit
            je      @F                                  ;go forward @@

            invoke  TranslateMessage, ADDR _msg 
            invoke  DispatchMessage,  ADDR _msg
            jmp     @B                                  ;go backward @@                  
            ;
            ; Termina o programa
            ;-------------------
@@:         invoke  ExitProcess, 0          
WinMain     endp
; 
GetDisplayDC    proc
                invoke    GetDC, _hWnd
                mov       _hdc, eax

                invoke  CreateFont, -10, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE, DEFAULT_CHARSET,\
                OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,\
                DEFAULT_QUALITY, DEFAULT_PITCH or FF_MODERN, addr _FontMSSSerif
                mov     _hFont0, eax
                invoke    SelectObject, _hdc, _hFont0

                invoke  GetTextMetrics, _hdc, addr _tm

                mov     eax, _tm.TEXTMETRIC.tmHeight
                mov     _ChrHeight, eax
                mov     eax, _tm.TEXTMETRIC.tmAveCharWidth
                mov     _ChrWidth, eax
                ret
GetDisplayDC    endp
; 
; process menuitems
; 
CmdProc         proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 
                ;
_iCmdProc::     SWITCH  edx

                case    IDM_Menu1               

                    cmp     _FlgEdita, 1
                    je      short _n

                    mov       eax, _LinCor
                    add       eax, 1
                    cmp       eax, 10
                    jbe       short @F

                    mov       eax, 4
                    
@@:                 mov       _LinCor, eax
                
                    invoke    EditaLin, hWnd, eax
                    invoke    SetFocus, _hEDIT1

                case    IDM_Menu2
                
                    cmp     _FlgEdita, 0
                    je      short _n

                    call    GetEditText               
                    
                default
_n:                 invoke   DefWindowProc, hWnd, uMsg, wParam, lParam
                ENDSW
                ;
                ; Command was processed
                ; *********************
                mov     eax, 0
                ret
CmdProc         endp
; 
WndProcA        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

                mov     edx, wParam
                mov     eax, uMsg

                ;cmp     eax, WM_SETFOCUS
                ;je      _WM_SETFOCUS
                cmp     eax, WM_SIZE
                je      _WM_SIZE

                cmp     eax, WM_COMMAND
                je      _iCmdProc               ; go to CmdProc           
                
                cmp     eax, WM_CREATE
                je      _WM_CREATE
                cmp     eax, WM_PAINT
                je      _WM_PAINT

                cmp     eax, WM_CLOSE
                je      _WM_CLOSE

                cmp     eax, WM_DESTROY
                je      _WM_DESTROY
                
                cmp     eax, WM_SYSCOMMAND
                je      _WM_SYSCOMMAND
; -----------------------------------------------------------------
_EndProcA::     invoke   DefWindowProc, hWnd, uMsg, wParam, lParam
                ret
; -----------------------------------------------------------------
;                             WM_CREATE
; -----------------------------------------------------------------
_WM_CREATE:   ; Font to window edit control
              invoke  CreateFont, -9, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE, DEFAULT_CHARSET,\
              OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,\
              DEFAULT_QUALITY, DEFAULT_PITCH or FF_MODERN, addr _FontMSSSerif
              mov     _hFont1, eax

              ;invoke    EditaLin, hWnd, _LinCor
              ;invoke    SetFocus, _hEDIT1

              jmp       _ExitProcA
; -----------------------------------------------------------------
;                             WM_SIZE
; -----------------------------------------------------------------
_WM_SIZE:     
              invoke    GetClientRect, _hWnd, ADDR _rc

              jmp       _ExitProcA
; -----------------------------------------------------------------
;                             WM_SETFOCUS
; -----------------------------------------------------------------
_WM_SETFOCUS:
		    ;invoke    SetFocus, _hEDIT1
                jmp       _ExitProcA
; -----------------------------------------------------------------
;                             WM_PAINT
_WM_PAINT:      invoke  PrintText, offset _TxtEDIT0, 1, 20

                invoke  PrintText, offset _TxtEDIT1, _LinCor, 5
                invoke  PrintText, offset _TxtEDIT2, _LinCor, 30
                invoke  PrintText, offset _TxtEDIT3, _LinCor, 55

                
                ;jmp       _ExitProcA
                jmp       _EndProcA                    
; -----------------------------------------------------------------
;                             WM_SYSCOMMAND

_WM_SYSCOMMAND: cmp     edx, SC_CLOSE
                jne     _EndProcA
; -----------------------------------------------------------------
;                             WM_CLOSE

_WM_CLOSE::     invoke    DestroyWindow,  hWnd
                jmp       _ExitProcA
; -----------------------------------------------------------------
;                             WM_DESTROY

_WM_DESTROY:    invoke   PostQuitMessage, NULL
                ;
_ExitProcA::    mov     eax, 0
                ret
WndProcA        endp
; 
EditaLin        proc    hWnd:DWORD, Lin:DWORD

                invoke    CriaEditBox, hWnd, Lin, 5, 20, 14, 500
                mov       _hEDIT1, eax                
;---------------------------------------------
                invoke    SendMessage, _hEDIT1, WM_SETFONT, _hFont1, TRUE
                invoke    SetWindowLong, _hEDIT1, GWL_WNDPROC, offset WndEdit1
                mov       _OldEdit1, eax

                invoke    CriaEditBox, hWnd, Lin, 30, 20, 14, 501
                mov       _hEDIT2, eax   
;---------------------------------------------
                invoke    SendMessage, _hEDIT2, WM_SETFONT, _hFont1, TRUE
                invoke    SetWindowLong, _hEDIT2, GWL_WNDPROC, offset WndEdit2
                mov       _OldEdit2, eax

                invoke    CriaEditBox, hWnd, Lin, 55, 20, 14, 502
                mov       _hEDIT3, eax                             
;---------------------------------------------
                invoke    SendMessage, _hEDIT3, WM_SETFONT, _hFont1, TRUE
                invoke    SetWindowLong, _hEDIT3, GWL_WNDPROC, offset WndEdit3
                mov       _OldEdit3, eax
;------------------------------------------
                invoke    SetWindowText, _hEDIT1, offset _TxtEDIT1
                invoke    SetWindowText, _hEDIT2, offset _TxtEDIT2
                invoke    SetWindowText, _hEDIT3, offset _TxtEDIT3
                ;
                ; this works too
                ;
                ;invoke    SendMessage, _hEDIT1, WM_SETTEXT, 0, offset _TxtEDIT1
                ;invoke    SendMessage, _hEDIT2, WM_SETTEXT, 0, offset _TxtEDIT2
                ;invoke    SendMessage, _hEDIT3, WM_SETTEXT, 0, offset _TxtEDIT3

                mov        _FlgEdita, 1
                ret
EditaLin        endp
; 
PrintText       proc    pRcl:DWORD, lin:DWORD, col:DWORD

                invoke  SetBkColor, _hdc, _BkColor
                invoke  SetTextColor, _hdc, 0000FFh

                mov     eax, col
                sub     eax, 1
                mul     _ChrWidth
                mov     ecx, eax
                ;  
                mov     eax, lin
                sub     eax, 1                  
                mul     _ChrHeight

                mov     edx, pRcl
                invoke  TextOut, _hdc, ecx, eax, edx, [edx - 4]

                ret
PrintText       endp
; 
GetEditText     proc
                push      ebx
                
                mov       ebx, offset _TxtEDIT1
                invoke    GetWindowText, _hEDIT1, ebx, [ebx - 8]
                mov       dword ptr [ebx - 4], eax

                mov       ebx, offset _TxtEDIT2
                invoke    GetWindowText, _hEDIT2, ebx, [ebx - 8]
                mov       dword ptr [ebx - 4], eax

                mov       ebx, offset _TxtEDIT3
                invoke    GetWindowText, _hEDIT3, ebx, [ebx - 8]
                mov       dword ptr [ebx - 4], eax

                invoke     SendMessage, _hEDIT1, WM_CLOSE, 0, 0
                invoke     SendMessage, _hEDIT2, WM_CLOSE, 0, 0
                invoke     SendMessage, _hEDIT3, WM_CLOSE, 0, 0

                mov        _FlgEdita, 0
                
                pop        ebx
                ret
GetEditText     endp
; 
WndEdit1        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
                push    ebx

                SWITCH  uMsg
                CASE    WM_CHAR

                    switch  wParam
                    case    VK_RETURN
                        
                        invoke  MessageBeep, MB_ICONASTERISK    
		            invoke  SetFocus, _hEDIT2
                        
                
                    case    VK_ESCAPE
                    
		            invoke  SetFocus, _hEDIT3

                        invoke  MessageBeep, MB_ICONHAND   

                    default
                        invoke  CallWindowProc, _OldEdit1, hWnd, uMsg, wParam, lParam
                        ret
                    endsw
                    ;
                    mov     eax, 0
                    pop     ebx                    
                    ret
; -----------------------------------------------------------------
                CASE    WM_KEYDOWN

                    switch  wParam
                    case    VK_END

                        call       GetEditText
                        invoke     SendMessage, _hWnd, WM_PAINT, 0, 0

                        invoke  MessageBeep, MB_ICONHAND
                    
                    default
                        invoke  CallWindowProc, _OldEdit1, hWnd, uMsg, wParam, lParam
                        ret
                    endsw
                    ;
                    mov     eax, 0
                    pop     ebx                    
                    ret
                DEFAULT
                    invoke  CallWindowProc, _OldEdit1, hWnd, uMsg, wParam, lParam
                    ret
                ENDSW
                ;
                mov     eax, 0
                pop     ebx                
                ret                
WndEdit1        endp
; 
WndEdit2        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
                push    ebx

                SWITCH  uMsg
                CASE    WM_CHAR

                    switch  wParam
                    case    VK_RETURN

                        invoke     MessageBeep, MB_ICONASTERISK    

		            invoke  SetFocus, _hEDIT3
                
                    case    VK_ESCAPE
                        
		            invoke    SetFocus, _hEDIT1

                        invoke  MessageBeep, MB_ICONHAND   

                    default
                        invoke  CallWindowProc, _OldEdit2, hWnd, uMsg, wParam, lParam
                        ret
                    endsw
                    ;
                    mov     eax, 0
                    pop     ebx                    
                    ret
; -----------------------------------------------------------------                    
                CASE    WM_KEYDOWN

                    switch  wParam
                    case    VK_END

                        call       GetEditText                        
                        invoke     SendMessage, _hWnd, WM_PAINT, 0, 0

                        invoke  MessageBeep, MB_ICONHAND
                    
                    default
                        invoke  CallWindowProc, _OldEdit2, hWnd, uMsg, wParam, lParam
                        ret
                    endsw
                    ;
                    mov     eax, 0
                    pop     ebx                    
                    ret                    
;..............................................................

                DEFAULT
                    invoke  CallWindowProc, _OldEdit2, hWnd, uMsg, wParam, lParam
                    ret
                ENDSW
                
                mov     eax, 0
                pop     ebx                
                ret                
WndEdit2        endp
; 
WndEdit3        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
                push    ebx
                
                SWITCH  uMsg
                CASE    WM_CHAR

                    switch  wParam
                    case    VK_RETURN


		            invoke    SetFocus, _hEDIT1

                        invoke  MessageBeep, MB_ICONASTERISK    

                
                    case    VK_ESCAPE

		            invoke    SetFocus, _hEDIT2

                        invoke  MessageBeep, MB_ICONHAND   

                    default
                        invoke  CallWindowProc, _OldEdit3, hWnd, uMsg, wParam, lParam
                        ret
                    endsw
                    ;
                    mov     eax, 0
                    pop     ebx
                    ret
; -----------------------------------------------------------------                    
                CASE    WM_KEYDOWN

                    switch  wParam
                    case    VK_END

                        call       GetEditText                        
                        invoke     SendMessage, _hWnd, WM_PAINT, 0, 0

                        invoke  MessageBeep, MB_ICONHAND
                    
                    default
                        invoke  CallWindowProc, _OldEdit3, hWnd, uMsg, wParam, lParam
                        ret
                    endsw
                    ;
                    mov     eax, 0
                    pop     ebx                    
                    ret                                        
;..............................................................
                DEFAULT
                    invoke  CallWindowProc, _OldEdit3, hWnd, uMsg, wParam, lParam
                    ret
                ENDSW
                
                mov     eax, 0
                pop     ebx                
                ret                
WndEdit3        endp
; 
CriaEditBox         proc    hWnd:DWORD, lin:DWORD, col:DWORD, w:DWORD, h:DWORD, id:DWORD
                    push    ebx

                    mov     eax, col
                    sub     eax, 1
                    mul     _ChrWidth
                    mov     ecx, eax
                    ;  
                    mov     eax, lin
                    sub     eax, 1                  
                    mul     _ChrHeight
                    mov     ebx, eax

                    mov     eax, w
                    mul     _ChrWidth

                    invoke   CreateWindowEx,  0, offset _EDITClass, 0,
                             EDITSTYLE2,
                             ecx, ebx, eax, h,
                             hWnd,
                             id, _hInstance, 0

                    pop     ebx
                    ret
CriaEditBox         endp
; ##############################################################################################
                                    ;include  Edit6.inc
; ##############################################################################################
    end     start
